//+------------------------------------------------------------------+
//|                                              RndTradeRndExit.mq4 |
//|                                            Copyright  2008 Grib |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Grib"
#property link      ""
#include       <common.mqh>
extern int iMagic = 100;
extern int iMaxTradeOpenTime = 1000;
extern int iMaxTimeBetweenTrades = 1000;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
static int iBuyCloseTime = 0;
static int iSellCloseTime = 0;
static int iBuyNextTradeTime = 0;
static int iSellNextTradeTime = 0;

MathSrand(TimeLocal());
double dRand1 = MathRand();
double dRand2 = MathRand();
double dRand3 = MathRand();
double dRand4 = MathRand();

//For first time run, set new random start times
if(iSellNextTradeTime == 0) iSellNextTradeTime = TimeLocal() + dRand3/32767 * iMaxTimeBetweenTrades;
if(iBuyNextTradeTime == 0) iBuyNextTradeTime = TimeLocal() + dRand4/32767 * iMaxTimeBetweenTrades;
//end first time run

   if(!SelectOrder(-1 ,iMagic,OP_SELL, -1, -1) && iSellNextTradeTime < TimeLocal())
   {
      OpenOrder(OP_SELL, iMagic);
      iSellCloseTime = TimeLocal() + dRand1/32767 * iMaxTradeOpenTime;
   }
   
   if(iSellCloseTime < TimeLocal() &&  SelectOrder(-1 ,iMagic,OP_SELL, -1, -1))
   {
      iSellNextTradeTime = TimeLocal() + dRand3/32767 * iMaxTimeBetweenTrades;
      CloseOrder(iMagic, OP_SELL);
      updateMoneyManager();
      updateOrderManager();
   }

   if(!SelectOrder(-1 ,iMagic,OP_BUY, -1, -1) && iBuyNextTradeTime < TimeLocal())
   {
      OpenOrder(OP_BUY, iMagic);
      iBuyCloseTime = TimeLocal() + dRand2/32767 * iMaxTradeOpenTime;
   }

   if(iBuyCloseTime < TimeLocal() && SelectOrder(-1 ,iMagic,OP_BUY, -1, -1))
   {
      iBuyNextTradeTime = TimeLocal() + dRand4/32767 * iMaxTimeBetweenTrades;
      CloseOrder(iMagic, OP_BUY);
      updateMoneyManager();
      updateOrderManager();
    }

//---------Comments----------
string sNextBuyTime = CheckStringTime(TimeToStr(iBuyNextTradeTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS));
string sBuyCloseTime = CheckStringTime(TimeToStr(iBuyCloseTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS));
string sNextSellTime = CheckStringTime(TimeToStr(iSellNextTradeTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS ));
string sSellCloseTime = CheckStringTime(TimeToStr(iSellCloseTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS ));
Comment( "Buy Orders"+"\n"+
         "Next Buy order in: "+sNextBuyTime+"\n"+
         "Closing Open Buy order in: "+sBuyCloseTime+"\n"+
         "\n"+
         "Sell Orders"+"\n"+
         "Next Sell order in: "+sNextSellTime+"\n"+
         "Closing Open Sell order in: "+sSellCloseTime+
"");
//---------Comments End -------   

}

string CheckStringTime(string sTime)
{
if(sTime == "invalid time")return("-");
else return(sTime);
}

//================ Open Orders =========================================================================================  
//

void OpenOrder(int iType, int iMagic)
{ 
      if(iType == OP_BUY) OrderSend(Symbol(),OP_BUY,lotsOptimized(Point),Ask,3,0,0,"TheRandomEA",iMagic,0,Blue);
      if(iType == OP_SELL) OrderSend(Symbol(),OP_SELL,lotsOptimized(Point),Bid,3,0,0,"TheRandomEA",iMagic,0,Blue);
}
//

//=============== Close Orders =========================================================================
//

void CloseOrder(int iMagic, int iType)
{
   RefreshRates();
   if(SelectOrder(-1 ,iMagic,iType, -1, -1))
   OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue); 
}
//

//=============== Select Orders =========================================================================
//
bool SelectOrder(string sOrderSymbol ,int iMagic, int iType, string sOrderComment, int iOrderTicket, int iPool = MODE_TRADES)
{
   int cnt,total=OrdersTotal();
     for(cnt=total-1;cnt>=0;cnt--)
      {
        OrderSelect(cnt, SELECT_BY_POS, iPool);
        if ((OrderSymbol() == sOrderSymbol || sOrderSymbol == "-1") && (OrderMagicNumber()==iMagic || iMagic == -1)  && (OrderType()==iType || iType == -1) && (OrderComment() == sOrderComment || sOrderComment =="-1")  && (OrderTicket() == iOrderTicket || iOrderTicket == -1))
        return(true);
      }
     return(false);
} 

